/* MuSE - Multiple Streaming Engine
 * Copyright (C) 2000-2002 Denis Roio aka jaromil <jaromil@dyne.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

class Entry;

class Playlist {
 private:
  Entry *pick(int pos);
 public:
  Playlist();
  ~Playlist();

  /* returns a pointer to the new allocated string into the playlist */
  char *add(const char *file);
  void rem(int pos);
  void clear();
  bool load(char *file);

  /* returns the full path of the element
     position starts from 1 */
  char *song(int pos);

  void sel(int pos);
  void sel(Entry *sel);
  int sel() { return pos(selected); };
  
  /* returns the position of the element
     as a number starting from 1
     -1 means error */
  int pos(Entry *sel);

  bool moveup(int pos);
  bool movedown(int pos);
  
  Entry *first;
  Entry *selected;
  Entry *last;
  int length;
  char *filename;
};

class Entry {
 public:
  Entry(const char *file);
  ~Entry();
  
  Entry *next;
  Entry *prev;
  char *name;
};
